Index: dods.py
===================================================================
--- dods.py	(revision 25214)
+++ dods.py	(working copy)
@@ -30,7 +30,7 @@
 
 import os
 import sys
-import gdal
+import gdal, osr
 
 sys.path.append( '../pymod' )
 
@@ -53,7 +53,7 @@
     if gdaltest.dods_dr is None:
         return 'skip'
 
-    gdaltest.dods_grid_ds = gdal.Open('http://disc1.sci.gsfc.nasa.gov/opendap/tovs/TOVSAMNF/1985/032/TOVS_MONTHLY_PM_8502_NF.HDF.Z?Data-Set-11[y][x]')
+    gdaltest.dods_grid_ds = gdal.Open('http://disc1.sci.gsfc.nasa.gov/opendap/tovs/TOVSAMNF/1985/032/TOVS_MONTHLY_PM_8502_NF.HDF.Z?Data_Set_11[y][x]')
 
     if gdaltest.dods_grid_ds is None:
         gdaltest.dods_dr = None
@@ -67,16 +67,16 @@
 def dods_2():
     if gdaltest.dods_dr is None:
         return 'skip'
-    tst = gdaltest.GDALTest( 'dods', 'http://disc1.sci.gsfc.nasa.gov/opendap/tovs/TOVSAMNF/1985/032/TOVS_MONTHLY_PM_8502_NF.HDF.Z?Data-Set-11', 1, 3391, filename_absolute = 1 )
+    tst = gdaltest.GDALTest( 'dods', 'http://disc1.sci.gsfc.nasa.gov/opendap/tovs/TOVSAMNF/1985/032/TOVS_MONTHLY_PM_8502_NF.HDF.Z?Data_Set_11', 1, 3391, filename_absolute = 1 )
     return tst.testOpen()
 
 ###############################################################################
-# Access all grids at once.
+# Access all data at once.
 
 def dods_3():
     if gdaltest.dods_dr is None:
         return 'skip'
-    tst = gdaltest.GDALTest( 'dods', 'http://disc1.sci.gsfc.nasa.gov/opendap/tovs/TOVSAMNF/1985/032/TOVS_MONTHLY_PM_8502_NF.HDF.Z', 12, 43208, filename_absolute = 1 )
+    tst = gdaltest.GDALTest( 'dods', 'http://disc1.sci.gsfc.nasa.gov/opendap/tovs/TOVSAMNF/1985/032/TOVS_MONTHLY_PM_8502_NF.HDF.Z', 135, 3444, filename_absolute = 1 )
     return tst.testOpen()
 
 ###############################################################################
@@ -85,7 +85,7 @@
 def dods_4():
     if gdaltest.dods_dr is None:
         return 'skip'
-    tst = gdaltest.GDALTest( 'dods', 'http://disc1.sci.gsfc.nasa.gov/opendap/tovs/TOVSAMNF/1985/032/TOVS_MONTHLY_PM_8502_NF.HDF.Z?Data-Set-11[y][x]', 1, 3391, filename_absolute = 1 )
+    tst = gdaltest.GDALTest( 'dods', 'http://disc1.sci.gsfc.nasa.gov/opendap/tovs/TOVSAMNF/1985/032/TOVS_MONTHLY_PM_8502_NF.HDF.Z?Data_Set_11[x][y]', 1, 2928, filename_absolute = 1 )
     return tst.testOpen()
 
 ###############################################################################
@@ -95,7 +95,7 @@
     if gdaltest.dods_dr is None:
         return 'skip'
 
-    tst = gdaltest.GDALTest( 'dods', 'http://disc1.sci.gsfc.nasa.gov/opendap/tovs/TOVSAMNF/1985/032/TOVS_MONTHLY_PM_8502_NF.HDF.Z?Data-Set-11[y][-x]', 1, 2436, filename_absolute = 1 )
+    tst = gdaltest.GDALTest( 'dods', 'http://disc1.sci.gsfc.nasa.gov/opendap/tovs/TOVSAMNF/1985/032/TOVS_MONTHLY_PM_8502_NF.HDF.Z?Data_Set_11[y][-x]', 1, 2436, filename_absolute = 1 )
     return tst.testOpen()
 
 ###############################################################################
@@ -119,6 +119,60 @@
         return 'success'
 
 ###############################################################################
+# Test reading all bands from 3D dataset
+
+def dods_7():
+    if gdaltest.dods_dr is None:
+        return 'skip'
+
+    tst = gdaltest.GDALTest( 'dods', 'http://disc1.sci.gsfc.nasa.gov/opendap/tovs/TOVSAMNF/1985/032/TOVS_MONTHLY_PM_8502_NF.HDF.Z?Data_Set_9', 5, 46869, filename_absolute = 1 )
+    return tst.testOpen()
+
+
+###############################################################################
+# Test reading third band from 3D dataset
+
+def dods_8():
+    if gdaltest.dods_dr is None:
+        return 'skip'
+
+    tst = gdaltest.GDALTest( 'dods', 'http://disc1.sci.gsfc.nasa.gov/opendap/tovs/TOVSAMNF/1985/032/TOVS_MONTHLY_PM_8502_NF.HDF.Z?Data_Set_9[3][x][y]', 1, 47041, filename_absolute = 1 )
+    return tst.testOpen()
+
+###############################################################################
+# Test reading metadata
+
+def dods_9():
+    if gdaltest.dods_dr is None:
+        return 'skip'
+    
+    ds = gdal.Open('http://disc1.sci.gsfc.nasa.gov/opendap/tovs/TOVSAMNF/1985/032/TOVS_MONTHLY_PM_8502_NF.HDF.Z')
+    dsBand1Metadata = ds.GetRasterBand(1).GetMetadata()
+    dsBand1Units = dsBand1Metadata.get('units', '')
+    if dsBand1Units != 'degrees K':
+        gdaltest.post_reason( 'metadata wrong or missing' )
+        print(dsBand1Units)
+        return 'fail'
+    else:
+        return 'success'
+
+###############################################################################
+# Test reading projection
+
+def dods_10():
+    if gdaltest.dods_dr is None:
+        return 'skip'
+    
+    src_osr = 'PROJCS["unnamed",GEOGCS["unnamed ellipse",DATUM["unknown",SPHEROID["unnamed",6378273,298.279409867652]],PRIMEM["Greenwich",0],UNIT["degree",0.0174532925199433]],PROJECTION["Polar_Stereographic"],PARAMETER["latitude_of_origin",70],PARAMETER["central_meridian",-45],PARAMETER["scale_factor",1],PARAMETER["false_easting",0],PARAMETER["false_northing",0],UNIT["kilometre",1000,AUTHORITY["EPSG","9036"]]]'
+    # NB: The NetCDF driver returns slightly different SRS from the the file:
+    # src_osr = 'PROJCS["unnamed",GEOGCS["WGS 84",DATUM["WGS_1984",SPHEROID["WGS 84",6378137,298.257223563,AUTHORITY["EPSG","7030"]],TOWGS84[0,0,0,0,0,0,0],AUTHORITY["EPSG","6326"]],PRIMEM["Greenwich",0,AUTHORITY["EPSG","8901"]],UNIT["degree",0.0174532925199433,AUTHORITY["EPSG","9108"]],AUTHORITY["EPSG","4326"]],PROJECTION["Polar_Stereographic"],PARAMETER["latitude_of_origin",70],PARAMETER["central_meridian",-45],PARAMETER["scale_factor",1],PARAMETER["false_easting",0],PARAMETER["false_northing",0],UNIT["kilometre",1000,AUTHORITY["EPSG","9036"]]]'
+    # Idealy DODS driver should inherit this functionality from NETCDF driver
+    tst = gdaltest.GDALTest( 'dods', 'http://thredds.met.no/thredds/dodsC/cryoclim/met.no/osisaf-nh/osisaf-nh_aggregated_ice_concentration_nh_polstere-100_200712010000.nc', 1, 5482, filename_absolute = 1 )
+    return tst.testOpen(check_prj=src_osr)
+
+
+
+###############################################################################
 # Cleanup
 
 def dods_cleanup():
@@ -139,6 +193,10 @@
     dods_4,
     dods_5,
     dods_6,
+    dods_7,
+    dods_8,
+    dods_9,
+    dods_10,    
     dods_cleanup ]
 
 
